#include "model.h"
#include <iostream>
#include <iomanip>
#include <cstring>
using std::setw;


Model::Model(string name)
{
    modelName=name;
}

Model::Model(const Model &model)
{
    modelName=model.modelName;
}

Model::Model()
{
    modelName="";
}
//this method loads obj model.
void Model::loadModel()
{

    const string modelPath="../import_geometry/models/welsh/";					//define the path where is located the obj file
    const string filePath=modelPath+modelName;			//contains the full path where is located the obj file
    //print general data of the model
    std::cout<<"--------------------------------------------------"<<std::endl;
    std::cout<<"\t          Model information"<<std::endl;
    std::cout<<"--------------------------------------------------"<<std::endl;
    if(strstr(modelName.c_str(),".obj")|| strstr(modelName.c_str(),".OBJ"))
    {
        std::cout<<"Loading Model "<< modelName.c_str()<<"...\n";
        int vert=objLoader.import(filePath.c_str());
        if(vert!=0){

            //Methods to get some characteristics of the model and initialize global variables.

            numVertices=objLoader.getNumberOfVertices();
            //numPrimitives=objLoader.getNumberOfTriangles();
            numPrimitives=objLoader.getNumberOfGeometries();
            numMaterials=objLoader.getNumberOfMaterials();
            numMeshes=objLoader.getNumberOfMeshes();
            numNormals=objLoader.getNumberOfNormals();
            //numAverages=objLoader.getNumberOfAverage();
            //middles=objLoader.getNumberOfMiddle();
            //standarD=objLoader.getNumberOfsDerivation();
            numAveragesX=objLoader.getNumberOfAverageX();
            middlesX=objLoader.getNumberOfMiddleX();
            standarDX=objLoader.getNumberOfsDerivationX();
            numAveragesY=objLoader.getNumberOfAverageY();
            middlesY=objLoader.getNumberOfMiddleY();
            standarDY=objLoader.getNumberOfsDerivationY();
            numAveragesZ=objLoader.getNumberOfAverageZ();
            middlesZ=objLoader.getNumberOfMiddleZ();
            standarDZ=objLoader.getNumberOfsDerivationZ();


            //print information about the model.
            std::cout<<"\nThe model " <<modelName<<" was loaded correctly.\n"<<std::endl;
            std::cout<<setw(22)<<"Number of Vertices: " <<setw(1)<<numVertices<<std::endl;
            std::cout<<setw(22)<<"Number of Primitives: " <<setw(1)<<numPrimitives<<std::endl;
            std::cout<<setw(22)<<"Number of Meshes: " <<setw(1)<<numMeshes<<std::endl;

            // In this part is called a method to characterize a scne.
            //objLoader.characterizeScene();

            //normailize model
            //objLoader.normalize();


            //print test of scene values
            /*float center[3]={0.0f};
            objLoader.getCenter(center[0],center[1],center[2]);
            std::cout<<objLoader.getHeight()<<std::endl;
            std::cout<<objLoader.getWidth()<<std::endl;
            std::cout<<objLoader.getLength()<<std::endl;
            std::cout<<center[0]<<center[1]<<center[2]<<std::endl;*/

        }
        else
        {
            std::cout<<"It was not posible to load "<<modelName<<std::endl;
            std::cout<<"--------------------------------------------------"<<std::endl;
            //exit(EXIT_FAILURE);
        }
    }
    else
        std::cout<<"the file: "<<modelName<<" was not able to load format not supported yet" <<std::endl;
}
